#include <gdk-pixbuf/gdk-pixbuf.h>
#include "graphics.h"

bool gen_jpeg(unsigned int height, unsigned int width,
      Color colored_pixels[height][width], const char* filename) {
   g_type_init();

   GdkPixbuf* pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8,
      width, height);
   int n_channels = gdk_pixbuf_get_n_channels(pixbuf);
   int rowstride = gdk_pixbuf_get_rowstride(pixbuf);
   guchar* pixels = gdk_pixbuf_get_pixels(pixbuf);
   if (!pixels) return false;
   for (int i = 0; i < height; ++i) {
      for (int j = 0; j < width; ++j) {
	 guchar* pp = pixels + i * rowstride + j * n_channels;
	 Color color = colored_pixels[i][j];
	 pp[0] = color.red * 255;
	 pp[1] = color.green * 255;
	 pp[2] = color.blue * 255;
      }
   }
   return gdk_pixbuf_save(pixbuf, filename, "jpeg", (GError **)0,
      "quality", "100", (void*)0);
   g_object_unref(pixbuf);
}
