#ifndef SIMULATION_H
#define SIMULATION_H

#include <stdbool.h>
#include "configuration.h"

typedef struct {
   unsigned int magnet_index; /* on which magnet did the pendulum halt? */
   double duration; /* how long did it take? */
   unsigned int iterations; /* number of iterations */
   bool success; /* is false if the maximal number of iterations was hit */
} SimulationResult;

SimulationResult simulate(double startx, double starty,
   const Configuration* conf);

#endif
